build.sh 18 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698
  1. #!/usr/bin/env bash
  2. # Copyright 2018 Google
  3. #
  4. # Licensed under the Apache License, Version 2.0 (the "License");
  5. # you may not use this file except in compliance with the License.
  6. # You may obtain a copy of the License at
  7. #
  8. # http://www.apache.org/licenses/LICENSE-2.0
  9. #
  10. # Unless required by applicable law or agreed to in writing, software
  11. # distributed under the License is distributed on an "AS IS" BASIS,
  12. # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  13. # See the License for the specific language governing permissions and
  14. # limitations under the License.
  15. # USAGE: build.sh product [platform] [method]
  16. #
  17. # Builds the given product for the given platform using the given build method
  18. function pod_gen() {
  19. # Call pod gen with a podspec and additional optional arguments.
  20. bundle exec pod gen --local-sources=./ --sources=https://github.com/firebase/SpecsDev.git,https://github.com/firebase/SpecsStaging.git,https://cdn.cocoapods.org/ "$@"
  21. }
  22. set -euo pipefail
  23. if [[ $# -lt 1 ]]; then
  24. cat 1>&2 <<EOF
  25. USAGE: $0 product [platform] [method]
  26. product can be one of:
  27. Firebase
  28. Firestore
  29. CombineSwift
  30. InAppMessaging
  31. Messaging
  32. MessagingSample
  33. SwiftUISample
  34. MLModelDownloaderSample
  35. RemoteConfig
  36. RemoteConfigSample
  37. Sessions
  38. Storage
  39. SymbolCollision
  40. GoogleDataTransport
  41. Performance
  42. ClientApp
  43. platform can be one of:
  44. iOS (default)
  45. iOS-device
  46. macOS
  47. tvOS
  48. watchOS
  49. catalyst
  50. visionOS
  51. method can be one of:
  52. xcodebuild (default)
  53. cmake
  54. unit
  55. integration
  56. spm
  57. Optionally, reads the environment variable SANITIZERS. If set, it is expected to
  58. be a string containing a space-separated list with some of the following
  59. elements:
  60. asan
  61. tsan
  62. ubsan
  63. EOF
  64. exit 1
  65. fi
  66. product="$1"
  67. platform="iOS"
  68. if [[ $# -gt 1 ]]; then
  69. platform="$2"
  70. fi
  71. method="xcodebuild"
  72. if [[ $# -gt 2 ]]; then
  73. method="$3"
  74. fi
  75. echo "Building $product for $platform using $method"
  76. if [[ -n "${SANITIZERS:-}" ]]; then
  77. echo "Using sanitizers: $SANITIZERS"
  78. fi
  79. scripts_dir=$(dirname "${BASH_SOURCE[0]}")
  80. firestore_emulator="${scripts_dir}/run_firestore_emulator.sh"
  81. database_emulator="${scripts_dir}/run_database_emulator.sh"
  82. system=$(uname -s)
  83. case "$system" in
  84. Darwin)
  85. xcode_version=$(xcodebuild -version | head -n 1)
  86. xcode_version="${xcode_version/Xcode /}"
  87. xcode_major="${xcode_version/.*/}"
  88. ;;
  89. *)
  90. xcode_major="0"
  91. ;;
  92. esac
  93. # Source function to check if CI secrets are available.
  94. source scripts/check_secrets.sh
  95. # Runs xcodebuild with the given flags, piping output to xcpretty
  96. # If xcodebuild fails with known error codes, retries once.
  97. function RunXcodebuild() {
  98. echo xcodebuild "$@"
  99. xcpretty_cmd=(xcpretty)
  100. result=0
  101. xcodebuild "$@" | tee xcodebuild.log | "${xcpretty_cmd[@]}" || result=$?
  102. if [[ $result == 65 ]]; then
  103. ExportLogs "$@"
  104. echo "xcodebuild exited with 65, retrying" 1>&2
  105. sleep 5
  106. result=0
  107. xcodebuild "$@" | tee xcodebuild.log | "${xcpretty_cmd[@]}" || result=$?
  108. fi
  109. if [[ $result != 0 ]]; then
  110. echo "xcodebuild exited with $result" 1>&2
  111. ExportLogs "$@"
  112. return $result
  113. fi
  114. }
  115. # Exports any logs output captured in the xcresult
  116. function ExportLogs() {
  117. python "${scripts_dir}/xcresult_logs.py" "$@"
  118. }
  119. if [[ "$xcode_major" -lt 15 ]]; then
  120. ios_flags=(
  121. -sdk 'iphonesimulator'
  122. -destination 'platform=iOS Simulator,name=iPhone 14'
  123. )
  124. else
  125. ios_flags=(
  126. -sdk 'iphonesimulator'
  127. -destination 'platform=iOS Simulator,name=iPhone 15'
  128. )
  129. fi
  130. ios_device_flags=(
  131. -sdk 'iphoneos'
  132. -destination 'generic/platform=iOS'
  133. )
  134. ipad_flags=(
  135. -sdk 'iphonesimulator'
  136. -destination 'platform=iOS Simulator,name=iPad Pro (9.7-inch)'
  137. )
  138. macos_flags=(
  139. -sdk 'macosx'
  140. -destination 'platform=OS X,arch=x86_64'
  141. )
  142. tvos_flags=(
  143. -sdk "appletvsimulator"
  144. -destination 'platform=tvOS Simulator,name=Apple TV'
  145. )
  146. watchos_flags=(
  147. -destination 'platform=watchOS Simulator,name=Apple Watch Series 7 (45mm)'
  148. )
  149. visionos_flags=(
  150. -destination 'platform=visionOS Simulator'
  151. )
  152. catalyst_flags=(
  153. ARCHS=x86_64 VALID_ARCHS=x86_64 SUPPORTS_MACCATALYST=YES -sdk macosx
  154. -destination platform="macOS,variant=Mac Catalyst,arch=x86_64" TARGETED_DEVICE_FAMILY=2
  155. CODE_SIGN_IDENTITY=- CODE_SIGNING_REQUIRED=NO CODE_SIGNING_ALLOWED=NO
  156. )
  157. # Compute standard flags for all platforms
  158. case "$platform" in
  159. iOS)
  160. xcb_flags=("${ios_flags[@]}")
  161. gen_platform=ios
  162. ;;
  163. iOS-device)
  164. xcb_flags=("${ios_device_flags[@]}")
  165. gen_platform=ios
  166. ;;
  167. iPad)
  168. xcb_flags=("${ipad_flags[@]}")
  169. ;;
  170. macOS)
  171. xcb_flags=("${macos_flags[@]}")
  172. gen_platform=macos
  173. ;;
  174. tvOS)
  175. xcb_flags=("${tvos_flags[@]}")
  176. gen_platform=tvos
  177. ;;
  178. watchOS)
  179. xcb_flags=("${watchos_flags[@]}")
  180. ;;
  181. visionOS)
  182. xcb_flags=("${visionos_flags[@]}")
  183. ;;
  184. catalyst)
  185. xcb_flags=("${catalyst_flags[@]}")
  186. ;;
  187. all)
  188. xcb_flags=()
  189. ;;
  190. Linux)
  191. xcb_flags=()
  192. ;;
  193. *)
  194. echo "Unknown platform '$platform'" 1>&2
  195. exit 1
  196. ;;
  197. esac
  198. xcb_flags+=(
  199. ONLY_ACTIVE_ARCH=YES
  200. CODE_SIGNING_REQUIRED=NO
  201. CODE_SIGNING_ALLOWED=YES
  202. COMPILER_INDEX_STORE_ENABLE=NO
  203. )
  204. # TODO(varconst): Add --warn-unused-vars and --warn-uninitialized.
  205. # Right now, it makes the log overflow on Travis because many of our
  206. # dependencies don't build cleanly this way.
  207. cmake_options=(
  208. -Wdeprecated
  209. -DCMAKE_BUILD_TYPE=Debug
  210. )
  211. if [[ -n "${SANITIZERS:-}" ]]; then
  212. for sanitizer in $SANITIZERS; do
  213. case "$sanitizer" in
  214. asan)
  215. xcb_flags+=(
  216. -enableAddressSanitizer YES
  217. )
  218. cmake_options+=(
  219. -DWITH_ASAN=ON
  220. )
  221. ;;
  222. tsan)
  223. xcb_flags+=(
  224. -enableThreadSanitizer YES
  225. )
  226. cmake_options+=(
  227. -DWITH_TSAN=ON
  228. )
  229. ;;
  230. ubsan)
  231. xcb_flags+=(
  232. -enableUndefinedBehaviorSanitizer YES
  233. )
  234. cmake_options+=(
  235. -DWITH_UBSAN=ON
  236. )
  237. ;;
  238. *)
  239. echo "Unknown sanitizer '$sanitizer'" 1>&2
  240. exit 1
  241. ;;
  242. esac
  243. done
  244. fi
  245. case "$product-$platform-$method" in
  246. FirebasePod-iOS-*)
  247. RunXcodebuild \
  248. -workspace 'CoreOnly/Tests/FirebasePodTest/FirebasePodTest.xcworkspace' \
  249. -scheme "FirebasePodTest" \
  250. "${xcb_flags[@]}" \
  251. build
  252. ;;
  253. Auth-*-xcodebuild)
  254. if check_secrets; then
  255. RunXcodebuild \
  256. -workspace 'FirebaseAuth/Tests/Sample/AuthSample.xcworkspace' \
  257. -scheme "Auth_ApiTests" \
  258. "${xcb_flags[@]}" \
  259. test
  260. RunXcodebuild \
  261. -workspace 'FirebaseAuth/Tests/Sample/AuthSample.xcworkspace' \
  262. -scheme "SwiftApiTests" \
  263. "${xcb_flags[@]}" \
  264. test
  265. fi
  266. ;;
  267. CombineSwift-*-xcodebuild)
  268. pod_gen FirebaseCombineSwift.podspec --platforms=ios
  269. RunXcodebuild \
  270. -workspace 'gen/FirebaseCombineSwift/FirebaseCombineSwift.xcworkspace' \
  271. -scheme "FirebaseCombineSwift-Unit-unit" \
  272. "${xcb_flags[@]}" \
  273. build \
  274. test
  275. ;;
  276. InAppMessaging-*-xcodebuild)
  277. RunXcodebuild \
  278. -workspace 'FirebaseInAppMessaging/Tests/Integration/DefaultUITestApp/InAppMessagingDisplay-Sample.xcworkspace' \
  279. -scheme 'FiamDisplaySwiftExample' \
  280. "${xcb_flags[@]}" \
  281. test
  282. ;;
  283. Firestore-*-xcodebuild)
  284. "${firestore_emulator}" start
  285. trap '"${firestore_emulator}" stop' ERR EXIT
  286. RunXcodebuild \
  287. -workspace 'Firestore/Example/Firestore.xcworkspace' \
  288. -scheme "Firestore_IntegrationTests_$platform" \
  289. -enableCodeCoverage YES \
  290. "${xcb_flags[@]}" \
  291. test
  292. ;;
  293. Firestore-macOS-cmake | Firestore-Linux-cmake)
  294. "${firestore_emulator}" start
  295. trap '"${firestore_emulator}" stop' ERR EXIT
  296. (
  297. test -d build || mkdir build
  298. cd build
  299. echo "Preparing cmake build ..."
  300. cmake -G Ninja "${cmake_options[@]}" ..
  301. echo "Building cmake build ..."
  302. ninja -k 10 all
  303. ctest --verbose
  304. )
  305. ;;
  306. SymbolCollision-*-*)
  307. RunXcodebuild \
  308. -workspace 'SymbolCollisionTest/SymbolCollisionTest.xcworkspace' \
  309. -scheme "SymbolCollisionTest" \
  310. "${xcb_flags[@]}" \
  311. build
  312. ;;
  313. # TODO(#12205) Restore this test to "test" instead of "build"
  314. Messaging-*-xcodebuild)
  315. pod_gen FirebaseMessaging.podspec --platforms=ios
  316. # Add GoogleService-Info.plist to generated Test Wrapper App.
  317. ruby ./scripts/update_xcode_target.rb gen/FirebaseMessaging/Pods/Pods.xcodeproj \
  318. AppHost-FirebaseMessaging-Unit-Tests \
  319. ../../../FirebaseMessaging/Tests/IntegrationTests/Resources/GoogleService-Info.plist
  320. if check_secrets; then
  321. # Integration tests are only run on iOS to minimize flake failures.
  322. RunXcodebuild \
  323. -workspace 'gen/FirebaseMessaging/FirebaseMessaging.xcworkspace' \
  324. -scheme "FirebaseMessaging-Unit-integration" \
  325. "${ios_flags[@]}" \
  326. "${xcb_flags[@]}" \
  327. build
  328. fi
  329. ;;
  330. MessagingSample-*-*)
  331. if check_secrets; then
  332. RunXcodebuild \
  333. -workspace 'FirebaseMessaging/Apps/Sample/Sample.xcworkspace' \
  334. -scheme "Sample" \
  335. "${xcb_flags[@]}" \
  336. build
  337. fi
  338. ;;
  339. SwiftUISample-*-*)
  340. if check_secrets; then
  341. RunXcodebuild \
  342. -workspace 'FirebaseMessaging/Apps/SwiftUISample/SwiftUISample.xcworkspace' \
  343. -scheme "SwiftUISample" \
  344. "${xcb_flags[@]}" \
  345. build
  346. fi
  347. ;;
  348. MessagingSampleStandaloneWatchApp-*-*)
  349. if check_secrets; then
  350. RunXcodebuild \
  351. -workspace 'FirebaseMessaging/Apps/SampleStandaloneWatchApp/SampleStandaloneWatchApp.xcworkspace' \
  352. -scheme "SampleStandaloneWatchApp Watch App" \
  353. "${xcb_flags[@]}" \
  354. build
  355. fi
  356. ;;
  357. MLModelDownloaderSample-*-*)
  358. if check_secrets; then
  359. RunXcodebuild \
  360. -workspace 'FirebaseMLModelDownloader/Apps/Sample/MLDownloaderTestApp.xcworkspace' \
  361. -scheme "MLDownloaderTestApp" \
  362. "${xcb_flags[@]}" \
  363. build
  364. fi
  365. ;;
  366. WatchOSSample-*-*)
  367. RunXcodebuild \
  368. -workspace 'Example/watchOSSample/SampleWatchApp.xcworkspace' \
  369. -scheme "SampleWatchAppWatchKitApp" \
  370. "${xcb_flags[@]}" \
  371. build
  372. ;;
  373. Database-*-integration)
  374. "${database_emulator}" start
  375. trap '"${database_emulator}" stop' ERR EXIT
  376. pod_gen FirebaseDatabase.podspec --platforms="${gen_platform}"
  377. RunXcodebuild \
  378. -workspace 'gen/FirebaseDatabase/FirebaseDatabase.xcworkspace' \
  379. -scheme "FirebaseDatabase-Unit-integration" \
  380. "${xcb_flags[@]}" \
  381. build \
  382. test
  383. ;;
  384. RemoteConfig-*-fakeconsole)
  385. pod_gen FirebaseRemoteConfigSwift.podspec --platforms="${gen_platform}"
  386. RunXcodebuild \
  387. -workspace 'gen/FirebaseRemoteConfigSwift/FirebaseRemoteConfigSwift.xcworkspace' \
  388. -scheme "FirebaseRemoteConfigSwift-Unit-fake-console-tests" \
  389. "${xcb_flags[@]}" \
  390. build \
  391. test
  392. ;;
  393. RemoteConfig-*-integration)
  394. pod_gen FirebaseRemoteConfigSwift.podspec --platforms="${gen_platform}"
  395. # Add GoogleService-Info.plist to generated Test Wrapper App.
  396. ruby ./scripts/update_xcode_target.rb gen/FirebaseRemoteConfigSwift/Pods/Pods.xcodeproj \
  397. AppHost-FirebaseRemoteConfigSwift-Unit-Tests \
  398. ../../../FirebaseRemoteConfigSwift/Tests/SwiftAPI/GoogleService-Info.plist
  399. # Add AccessToken to generated Test Wrapper App.
  400. ruby ./scripts/update_xcode_target.rb gen/FirebaseRemoteConfigSwift/Pods/Pods.xcodeproj \
  401. AppHost-FirebaseRemoteConfigSwift-Unit-Tests \
  402. ../../../FirebaseRemoteConfigSwift/Tests/AccessToken.json
  403. RunXcodebuild \
  404. -workspace 'gen/FirebaseRemoteConfigSwift/FirebaseRemoteConfigSwift.xcworkspace' \
  405. -scheme "FirebaseRemoteConfigSwift-Unit-swift-api-tests" \
  406. "${xcb_flags[@]}" \
  407. build \
  408. test
  409. ;;
  410. RemoteConfigSample-*-*)
  411. RunXcodebuild \
  412. -workspace 'FirebaseRemoteConfig/Tests/Sample/RemoteConfigSampleApp.xcworkspace' \
  413. -scheme "RemoteConfigSampleApp" \
  414. "${xcb_flags[@]}" \
  415. build
  416. ;;
  417. Sessions-*-integration)
  418. # Perform "pod install" to install the relevant dependencies
  419. # ./FirebaseSessions/generate_testapp.sh
  420. pod_gen FirebaseSessions.podspec --platforms=ios --clean
  421. cd FirebaseSessions/Tests/TestApp; pod install; cd -
  422. # Run E2E Integration Tests for Prod.
  423. RunXcodebuild \
  424. -workspace 'FirebaseSessions/Tests/TestApp/AppQualityDevApp.xcworkspace' \
  425. -scheme "AppQualityDevApp_iOS" \
  426. "${ios_flags[@]}" \
  427. "${xcb_flags[@]}" \
  428. build \
  429. test
  430. # Run E2E Integration Tests for Staging.
  431. RunXcodebuild \
  432. -workspace 'FirebaseSessions/Tests/TestApp/AppQualityDevApp.xcworkspace' \
  433. -scheme "AppQualityDevApp_iOS" \
  434. FirebaseSessionsRunEnvironment=STAGING \
  435. "${ios_flags[@]}" \
  436. "${xcb_flags[@]}" \
  437. build \
  438. test
  439. # Run E2E Integration Tests for Autopush.
  440. RunXcodebuild \
  441. -workspace 'FirebaseSessions/Tests/TestApp/AppQualityDevApp.xcworkspace' \
  442. -scheme "AppQualityDevApp_iOS" \
  443. FirebaseSessionsRunEnvironment=AUTOPUSH \
  444. "${ios_flags[@]}" \
  445. "${xcb_flags[@]}" \
  446. build \
  447. test
  448. ;;
  449. StorageSwift-*-xcodebuild)
  450. pod_gen FirebaseStorage.podspec --platforms=ios
  451. # Add GoogleService-Info.plist to generated Test Wrapper App.
  452. ruby ./scripts/update_xcode_target.rb gen/FirebaseStorage/Pods/Pods.xcodeproj \
  453. AppHost-FirebaseStorage-Unit-Tests \
  454. ../../../FirebaseStorage/Tests/Integration/Resources/GoogleService-Info.plist
  455. if check_secrets; then
  456. # Integration tests are only run on iOS to minimize flake failures.
  457. RunXcodebuild \
  458. -workspace 'gen/FirebaseStorage/FirebaseStorage.xcworkspace' \
  459. -scheme "FirebaseStorage-Unit-integration" \
  460. "${ios_flags[@]}" \
  461. "${xcb_flags[@]}" \
  462. test
  463. fi
  464. ;;
  465. StorageObjC-*-xcodebuild)
  466. pod_gen FirebaseStorage.podspec --platforms=ios
  467. # Add GoogleService-Info.plist to generated Test Wrapper App.
  468. ruby ./scripts/update_xcode_target.rb gen/FirebaseStorage/Pods/Pods.xcodeproj \
  469. AppHost-FirebaseStorage-Unit-Tests \
  470. ../../../FirebaseStorage/Tests/Integration/Resources/GoogleService-Info.plist
  471. if check_secrets; then
  472. # Integration tests are only run on iOS to minimize flake failures.
  473. RunXcodebuild \
  474. -workspace 'gen/FirebaseStorage/FirebaseStorage.xcworkspace' \
  475. -scheme "FirebaseStorage-Unit-ObjCIntegration" \
  476. "${ios_flags[@]}" \
  477. "${xcb_flags[@]}" \
  478. test
  479. fi
  480. ;;
  481. StorageCombine-*-xcodebuild)
  482. pod_gen FirebaseCombineSwift.podspec --platforms=ios
  483. # Add GoogleService-Info.plist to generated Test Wrapper App.
  484. ruby ./scripts/update_xcode_target.rb gen/FirebaseCombineSwift/Pods/Pods.xcodeproj \
  485. AppHost-FirebaseCombineSwift-Unit-Tests \
  486. ../../../FirebaseStorage/Tests/Integration/Resources/GoogleService-Info.plist
  487. if check_secrets; then
  488. # Integration tests are only run on iOS to minimize flake failures.
  489. RunXcodebuild \
  490. -workspace 'gen/FirebaseCombineSwift/FirebaseCombineSwift.xcworkspace' \
  491. -scheme "FirebaseCombineSwift-Unit-integration" \
  492. "${ios_flags[@]}" \
  493. "${xcb_flags[@]}" \
  494. test
  495. fi
  496. ;;
  497. GoogleDataTransport-watchOS-xcodebuild)
  498. RunXcodebuild \
  499. -workspace 'GoogleDataTransport/GDTWatchOSTestApp/GDTWatchOSTestApp.xcworkspace' \
  500. -scheme "GDTWatchOSTestAppWatchKitApp" \
  501. "${xcb_flags[@]}" \
  502. build
  503. RunXcodebuild \
  504. -workspace 'GoogleDataTransport/GDTCCTWatchOSTestApp/GDTCCTWatchOSTestApp.xcworkspace' \
  505. -scheme "GDTCCTWatchOSIndependentTestAppWatchKitApp" \
  506. "${xcb_flags[@]}" \
  507. build
  508. RunXcodebuild \
  509. -workspace 'GoogleDataTransport/GDTCCTWatchOSTestApp/GDTCCTWatchOSTestApp.xcworkspace' \
  510. -scheme "GDTCCTWatchOSCompanionTestApp" \
  511. "${xcb_flags[@]}" \
  512. build
  513. ;;
  514. Performance-*-unit)
  515. # Run unit tests on prod environment with unswizzle capabilities.
  516. export FPR_UNSWIZZLE_AVAILABLE="1"
  517. export FPR_AUTOPUSH_ENV="0"
  518. pod_gen FirebasePerformance.podspec --platforms="${gen_platform}"
  519. RunXcodebuild \
  520. -workspace 'gen/FirebasePerformance/FirebasePerformance.xcworkspace' \
  521. -scheme "FirebasePerformance-Unit-unit" \
  522. "${xcb_flags[@]}" \
  523. build \
  524. test
  525. ;;
  526. Performance-*-proddev)
  527. # Build the prod dev test app.
  528. export FPR_UNSWIZZLE_AVAILABLE="0"
  529. export FPR_AUTOPUSH_ENV="0"
  530. pod_gen FirebasePerformance.podspec --platforms="${gen_platform}"
  531. RunXcodebuild \
  532. -workspace 'gen/FirebasePerformance/FirebasePerformance.xcworkspace' \
  533. -scheme "FirebasePerformance-TestApp" \
  534. "${xcb_flags[@]}" \
  535. build
  536. ;;
  537. Performance-*-integration)
  538. # Generate the workspace for the SDK to generate Protobuf files.
  539. export FPR_UNSWIZZLE_AVAILABLE="0"
  540. pod_gen FirebasePerformance.podspec --platforms=ios --clean
  541. # Perform "pod install" to install the relevant dependencies
  542. cd FirebasePerformance/Tests/FIRPerfE2E; pod install; cd -
  543. # Run E2E Integration Tests for Autopush.
  544. RunXcodebuild \
  545. -workspace 'FirebasePerformance/Tests/FIRPerfE2E/FIRPerfE2E.xcworkspace' \
  546. -scheme "FIRPerfE2EAutopush" \
  547. FPR_AUTOPUSH_ENV=1 \
  548. "${ios_flags[@]}" \
  549. "${xcb_flags[@]}" \
  550. build \
  551. test
  552. # Run E2E Integration Tests for Prod.
  553. RunXcodebuild \
  554. -workspace 'FirebasePerformance/Tests/FIRPerfE2E/FIRPerfE2E.xcworkspace' \
  555. -scheme "FIRPerfE2EProd" \
  556. "${ios_flags[@]}" \
  557. "${xcb_flags[@]}" \
  558. build \
  559. test
  560. ;;
  561. # Note that the combine tests require setting the minimum iOS and tvOS version to 13.0
  562. *-*-spm)
  563. RunXcodebuild \
  564. -scheme $product \
  565. "${xcb_flags[@]}" \
  566. IPHONEOS_DEPLOYMENT_TARGET=13.0 \
  567. TVOS_DEPLOYMENT_TARGET=13.0 \
  568. test
  569. ;;
  570. *-*-spmbuildonly)
  571. RunXcodebuild \
  572. -scheme $product \
  573. "${xcb_flags[@]}" \
  574. build
  575. ;;
  576. ClientApp-iOS-xcodebuild | ClientApp-iOS13-iOS-xcodebuild)
  577. RunXcodebuild \
  578. -project 'IntegrationTesting/ClientApp/ClientApp.xcodeproj' \
  579. -scheme $product \
  580. "${xcb_flags[@]}" \
  581. build
  582. ;;
  583. ClientApp-CocoaPods*-iOS-xcodebuild)
  584. RunXcodebuild \
  585. -workspace 'IntegrationTesting/ClientApp/ClientApp.xcworkspace' \
  586. -scheme $product \
  587. "${xcb_flags[@]}" \
  588. build
  589. ;;
  590. *)
  591. echo "Don't know how to build this product-platform-method combination" 1>&2
  592. echo " product=$product" 1>&2
  593. echo " platform=$platform" 1>&2
  594. echo " method=$method" 1>&2
  595. exit 1
  596. ;;
  597. esac